#ifndef QUEUE_H
#define QUEUE_H

/**
 * Queue structure.
 */
typedef struct Queue_ Queue;

/**
 * Create/allocate a new integer queue.
 */
Queue* createQueue();

/**
 * Free/deallocate a queue.
 */
void freeQueue(Queue* q);

/**
 * Insert a new value into the end of given queue.
 */
void enqueue(Queue* q, int value);

/**
 * Get the number of elements in queue.
 */
int queueSize(Queue* q);

/**
 * Remove and get the first value in given queue. Can't handle empty queue!
 */
int dequeue(Queue* q);


#endif
